----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    00:47:21 12/07/2011 
-- Design Name: 
-- Module Name:    display_7seg - display 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity display_7seg is
	port (
		clk_i : IN std_logic;
		rst_i : IN std_logic;
		digit_i : IN std_logic_vector(31 downto 0);
		led7_an_o : OUT std_logic_vector(3 downto 0);
		led7_seg_o : OUT std_logic_vector(7 downto 0)
	);
end display_7seg;

architecture display of display_7seg is
begin
	process(clk_i,rst_i) is
	variable cnt : integer range 0 to 3;
	begin  
		if rst_i = '1' then
			cnt := 0;
			led7_an_o <= "0000";
			led7_seg_o <= X"00";
		elsif rising_edge(clk_i) then
			if cnt = 3 then
				cnt := 0;
				led7_an_o <= "0111";
				led7_seg_o <= digit_i(31 downto 24);
			elsif cnt = 2 then
				cnt := 3;
				led7_an_o <= "1110";
				led7_seg_o <= digit_i(7 downto 0);
			elsif cnt = 1 then
				cnt := 2;
				led7_an_o <= "1101";
				led7_seg_o <= digit_i(15 downto 8);
			else
				cnt := 1;
				led7_an_o <= "1011";
				led7_seg_o <= digit_i(23 downto 16);
			end if;
		end if;
	end process;
end display;

